#include <stdio.h>
#include <ADUC812.H>

void main (void)
{
/*-------------------------------------
Setup the serial port
-------------------------------------*/
SCON  = 0x50;
TMOD |= 0x20;
TH1   = 0xFA;
TR1   = 1;
TI    = 1;
PCON |= 0x80;

/*-------------------------------------
Configure the D/A converters:
  12-bit mode, 0-VDD range, DAC0 DAC1
  DACCON = 0111 1?01
-------------------------------------*/
DACCON = 0x7B;               

/*-------------------------------------
Loop thru all 4096 counts updating
DAC0 and DAC1.
-------------------------------------*/
while (1)
  {
  unsigned int i;

// Full 12 bit scale: 2^12 = 4096
  for (i = 0; i < 4096; i++)   
    {
    DACCON &= ~0x04;   // CLR SYNC bit

    DAC0H = i >> 8;
    DAC0L = i & 0xFF;

    DAC1H = (4095 - i) >> 8;
    DAC1L = (4095 - i) & 0xFF;

    DACCON |=  0x04;   // SET SYNC bit

    printf ("Output %4.4X to DAC0 (%1.4fV)  ", (unsigned) i, (float) i * 5.0 / 4095.0);
    printf ("Output %4.4X to DAC1 (%1.4fV)\n", (unsigned) 4095-i, (float) (4095-i) * 5.0 / 4095.0);
    }
  }
}


